package net.udby.test.db.lock;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.concurrent.CountDownLatch;

public class UpdateRSRunner extends SimpleRunner {

    public UpdateRSRunner(TestDriver driver, ConnectionSpec cs, CountDownLatch start, CountDownLatch go) {
        super(driver, cs, start, go);
    }

    /* (non-Javadoc)
     * @see net.udby.test.db.lock.SimpleRunner#prepareSelectStatement()
     */
    @Override
    protected PreparedStatement prepareSelectStatement() throws SQLException {
        return cs.getConnection().prepareStatement(getSelectSql(), ResultSet.TYPE_FORWARD_ONLY, ResultSet.CONCUR_UPDATABLE);
    }

    /* (non-Javadoc)
     * @see net.udby.test.db.lock.SimpleRunner#updateRow(java.sql.ResultSet)
     */
    @Override
    protected int updateRow(ResultSet rs) throws SQLException {
        int n = rs.getInt(1) + 1;
        rs.updateInt(1, n);
        rs.updateRow();
        return n;
    }
    
}
